\chapter{Configurable Coherence Subsystem} \label{chapt:coherence}
%
%
\vskip 1cm
%
%

Nu+ tiles are organized in a mesh configuration featuring a shared-memory model. Logically, all processors have the same view of the memory, with the coherence subsystem managing each line in a transparent way for the local accelerator. Memory hierarchies use caches to improve the performance, reducing the latency to access data, but the implementation of such mechanisms complicate the logical and is highly error-prone. This Chapter introduces the baseline coherence subsystem of the nu+ many-core, describing its main actors, their designs, and the how they are integrated in the baseline tile exposed in the previous Chapter.

\begin{figure}[t]
	\centering
	\includegraphics[width=1\textwidth]{Chapters/Cohe/figures/LDST_CC.eps}
	\caption{The nu+ coherence sub-system overview.}
	\label{fig:ldst_cc}
\end{figure}

\section{Cache Hierarchy}

The nu+ many-core features a distributed L2 cache organization, each of the baseline tiles allocates $N$ banks of the L2 cache accessible from others, while the L1 is private to the local accelerator. %With a shared L2 cache, a L1 miss will be sent to a L2 bank determined by the miss address (not necessarily the local L2 bank), where it could hit in the L2 bank or miss and be sent off-chip to access main memory.

Shared caches represent a more effective use of storage as there is no replication of cache lines. However, L1 cache miss incurs additional latency to request data from a different tile. Shared caches place more pressure on the interconnection network as L1 misses might go onto the network, but through more effective use of storage may reduce pressure on the main memory. %With shared caches, more requests will travel to remote nodes for data. Using this configuration the on-chip network must attach to both the L1s and the L2.

The \texttt{Memory Controller} is placed as individual node on the interconnection network; with this design, the memory controller does not have to share injection/ejection bandwidth to/from the network with accelerators. %In this way traffic is more isolated; the memory controller has access to the full amount of injection bandwidth.

\subsection{Architectural Details}

The coherence subsystem is composed of three components further described in the remainder of this Chapter:

\begin{enumerate}
	\item Load/store unit: manages L1 data cache, located at the accelerator level.
	\item Cache controller: handles L1 coherence data cache and manages coherence transactions.
	\item Directory controller: handles L2 cache and manages coherence transactions from cache controllers.
\end{enumerate}

Load/store unit is part of nu+ core while cache controller and directory control are allocated at the tile level.

\input{Chapters/Cohe/ldst.tex}
\input{Chapters/Cohe/cachecontroller.tex}
\input{Chapters/Cohe/directorycontroller.tex}










